/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export type OpaqueString<Key extends string> = string & {
    __opaque: Key;
};

export type DateString = OpaqueString<"Date">;

export type DateTimeString = OpaqueString<"DateTime">;

export type IdString = OpaqueString<"Id">;

export type OpaqueNumber<Key extends string> = number & {
    __opaque: Key;
};

export type IdNumber = OpaqueNumber<"Id">;

export interface IExampleOpaqueTypes {
    date: DateString;
    dateTime: DateTimeString;
    idString: IdString;
    idNumber: IdNumber;
}

export interface TestGetParams {
    id: IdString;
}

export class TestController {
    constructor(private fetcher: IFetcher) { }
    get = (params: TestGetParams, headers?: HeaderMap): Promise<IExampleOpaqueTypes> => {
        return this.fetcher.request<IExampleOpaqueTypes>(`test/get/${params.id}`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    test = new TestController(this.fetcher);
}